﻿package {
	// imports
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.ErrorEvent;
	import flash.events.MouseEvent;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.xml.XMLDocument;
	import flash.events.TimerEvent;
	import flash.utils.Timer;
	
	public class XMLSlideshow extends Sprite {
		
		// --- stuff to configure begin ---
		
		var xmlFileLoc:String = "xmlfile.xml"; //location of xml file
		var minuteTimer:Timer = new Timer(7000, 0); // 7000 = 7 seconds
		
		// --- stuff to configure end ---		
		
		//declare variables
		private var urlLoader:URLLoader;
		public static  var data:XML;
		private var myIndex:Number;
		private var i:uint;
		private var cNodes:Array;
		private var child1:Picloader = new Picloader();
		private var child2:Picloader = new Picloader();
		private var contLoaded:uint;
		var _control:Control = new Control();
		var inPlaying:Boolean;
		
		//constructor
		public function XMLSlideshow() {

			xmlLoader();
			
			_control.txtDesc.text = "";
			minuteTimer.addEventListener(TimerEvent.TIMER, onTick);
			minuteTimer.start();
			isPlaying = true;

			child1.x = child1.y = 0;
			addChild(child1);
			child2.x = child2.y = 0;
			addChild(child2);

			addChild(_control);
			setChildIndex(_control, this.numChildren - 1);
			_control.x = 400;
			_control.y = 15;
			_control.mcCtrlBg.alpha = _control.btnPause.alpha = 0.4;
			_control.btnForward.alpha = _control.btnBack.alpha = 0;

			_control.btnPause.addEventListener(MouseEvent.MOUSE_OVER, ctrlOver);
			_control.btnPause.addEventListener(MouseEvent.MOUSE_OUT, ctrlOut);
			_control.btnPause.addEventListener(MouseEvent.CLICK, ctrlStop);
		}
		
		// control stuff
		private function ctrlOver(evt:Event):void {
			evt.target.alpha = 1;
			if (evt.target.name == "btnPause") {
				if (isPlaying == true) {
					_control.txtDesc.text = "Pause";
				} else {
					_control.txtDesc.text = "Play";
				}
			} else if (evt.target.name == "btnForward") {
				_control.txtDesc.text = "Next";
			} else if (evt.target.name == "btnBack") {
				_control.txtDesc.text = "Back";
			}

		}
		
		private function ctrlOut(evt:Event):void {

			evt.target.alpha = 0.4;
			_control.txtDesc.text = "";

		}
		
		//stop button
		private function ctrlStop(evt:Event):void {
			if (isPlaying == true) {
				minuteTimer.stop();
				isPlaying = false;
				_control.btnForward.alpha = _control.btnBack.alpha = 0.4;
				_control.btnBack.addEventListener(MouseEvent.MOUSE_OVER, ctrlOver);
				_control.btnForward.addEventListener(MouseEvent.MOUSE_OVER, ctrlOver);
				_control.btnBack.addEventListener(MouseEvent.MOUSE_OUT, ctrlOut);
				_control.btnForward.addEventListener(MouseEvent.MOUSE_OUT, ctrlOut);
				_control.btnBack.addEventListener(MouseEvent.CLICK, ctrlBack);
				_control.btnForward.addEventListener(MouseEvent.CLICK, ctrlForward);
				_control.txtDesc.text = "Play";
			} else {
				minuteTimer.start();
				isPlaying = true;
				_control.btnForward.alpha = _control.btnBack.alpha = 0;
				_control.btnBack.removeEventListener(MouseEvent.MOUSE_OVER, ctrlOver);
				_control.btnForward.removeEventListener(MouseEvent.MOUSE_OVER, ctrlOver);
				_control.btnBack.removeEventListener(MouseEvent.MOUSE_OUT, ctrlOut);
				_control.btnForward.removeEventListener(MouseEvent.MOUSE_OUT, ctrlOut);
				_control.btnBack.removeEventListener(MouseEvent.CLICK, ctrlBack);
				_control.btnForward.removeEventListener(MouseEvent.CLICK, ctrlForward);
				_control.txtDesc.text = "Pause";

			}
		}
		
		//forward button
		private function ctrlForward(evt:Event):void {
			if (contLoaded == 1) {
				setChildIndex(child2, this.numChildren - 2);
				if (i == cNodes.length - 1) {
					i = 0;
				} else {
					i += 1;
				}
				child2.myLoader(i);
				contLoaded = 2;
			} else if (contLoaded == 2) {

				setChildIndex(child1, this.numChildren - 2);
				if (i == cNodes.length - 1) {
					i = 0;
				} else {
					i += 1;
				}
				child1.myLoader(i);
				contLoaded = 1;
			}
		}
		
		//back button
		private function ctrlBack(evt:Event):void {

			if (contLoaded == 1) {
				setChildIndex(child2, this.numChildren - 2);
				if (i == 0) {
					i = cNodes.length - 1;
				} else {
					i -= 1;
				}
				child2.myLoader(i);
				contLoaded = 2;
			} else if (contLoaded == 2) {
				setChildIndex(child1, this.numChildren - 2);
				if (i == 0) {
					i = cNodes.length - 1;
				} else {
					i -= 1;
				}
				child1.myLoader(i);
				contLoaded = 1;
			}
		}

		//xml stuff
		public function xmlLoader():void {
			var URL:String = xmlFileLoc;
			var urlRequest:URLRequest = new URLRequest(URL);
			urlLoader = new URLLoader();
			urlLoader.addEventListener("complete", onLoaded);
			urlLoader.addEventListener("ioerror", ifFailed);
			urlLoader.load(urlRequest);
		}

		private function onLoaded(event:Event):void {
			data = XML(urlLoader.data);
			parseData(data);
			child1.myLoader(0);
			contLoaded = 1;
			i = 0;
		}

		private function ifFailed(errorEvent:ErrorEvent):void {
			trace("ERROR");
		}
		private function parseData(data:XML):void {

			var x2:XMLDocument = new XMLDocument ();
			x2.ignoreWhite = true;
			var list:String = data.toXMLString ();
			x2.parseXML(list);
			cNodes = x2.firstChild.childNodes;
			
		}

		//timer function
		public function onTick(event:TimerEvent):void {

			if (contLoaded == 1) {
				setChildIndex(child2, this.numChildren - 2);
				if (i == cNodes.length - 1) {
					i = 0;
					child2.myLoader(i);
				} else {
					i += 1;
					child2.myLoader(i);
				}
				
				contLoaded = 2;

			} else if (contLoaded == 2) {
				setChildIndex(child1, this.numChildren - 2);
				if (i == cNodes.length - 1) {
					i = 0;
					child1.myLoader(i);
				} else {
					i += 1;
					child1.myLoader(i);
				}
				contLoaded = 1;
			}
		}
	}
}